## org.apache.jasper.runtime
Class BodyContentImpl

    java.lang.Object
      java.io.Writer
          javax.servlet.jsp.JspWriter
              javax.servlet.jsp.tagext.BodyContent
                  org.apache.jasper.runtime.BodyContentImpl

public class BodyContentImpl
extends javax.servlet.jsp.tagext.BodyContent

Write text to a character-output stream, buffering characters so as to provide for the efficient writing of single characters, arrays, and strings. Provide support for discarding for the output that has been buffered.

Author:
  Rajiv Mordani

Field Summary
`protected int` `bufferSize`

Fields inherited from class javax.servlet.jsp.JspWriter
`autoFlush, DEFAULT_BUFFER, NO_BUFFER, UNBOUNDED_BUFFER`

Fields inherited from class java.io.Writer
`lock`

Constructor Summary
`BodyContentImpl(javax.servlet.jsp.JspWriter writer)`

Method Summary
`void` `clear()` Clear the contents of the buffer.
`void` `clearBuffer()` Clears the current contents of the buffer.
`void` `close()` Close the stream, flushing it first.
`java.io.Reader` `getReader()` Return the value of this BodyJspWriter as a Reader.
`int` `getRemaining()`
`java.lang.String` `getString()` Return the value of the BodyJspWriter as a String.
`static void` `main(java.lang.String[] args)`
`void` `newLine()` Write a line separator.
`void` `print(boolean b)` Print a boolean value.
`void` `print(char c)` Print a character.
`void` `print(char[] s)` Print an array of characters.
`void` `print(double d)` Print a double-precision floating-point number.
`void` `print(float f)` Print a floating-point number.
`void` `print(int i)` Print an integer.
`void` `print(long l)` Print a long integer.
`void` `print(java.lang.Object obj)` Print an object.
`void` `print(java.lang.String s)` Print a string.
`void` `println()` Terminate the current line by writing the line separator string.
`void` `println(boolean x)` Print a boolean value and then terminate the line.
`void` `println(char x)` Print a character and then terminate the line.
`void` `println(char[] x)` Print an array of characters and then terminate the line.
`void` `println(double x)` Print a double-precision floating-point number and then terminate the line.
`void` `println(float x)` Print a floating-point number and then terminate the line.
`void` `println(int x)` Print an integer and then terminate the line.
`void` `println(long x)` Print a long integer and then terminate the line.
`void` `println(java.lang.Object x)` Print an Object and then terminate the line.
`void` `println(java.lang.String x)` Print a String and then terminate the line.
`void` `write(char[] buf)` Write an array of characters.
`void` `write(char[] cbuf, int off, int len)` Write a portion of an array of characters.
`void` `write(int c)` Write a single character.
`void` `write(java.lang.String s)` Write a string.
`void` `write(java.lang.String s, int off, int len)` Write a portion of a String.
`void` `writeOut(java.io.Writer out)` Write the contents of this BodyJspWriter into a Writer.

Methods inherited from class javax.servlet.jsp.tagext.BodyContent
`clearBody, flush, getEnclosingWriter`

Methods inherited from class javax.servlet.jsp.JspWriter
`getBufferSize, isAutoFlush`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### bufferSize

    protected int bufferSize

Constructor Detail

### BodyContentImpl

    public BodyContentImpl(javax.servlet.jsp.JspWriter writer)

Method Detail

### write

    public void write(int c)
               throws java.io.IOException

  Write a single character.

  Throws:
    `java.io.IOException`

### write

    public void write(char[] cbuf,
                      int off,
                      int len)
               throws java.io.IOException

  Write a portion of an array of characters.

  Ordinarily this method stores characters from the given array into this stream's buffer, flushing the buffer to the underlying stream as needed. If the requested length is at least as large as the buffer, however, then this method will flush the buffer and write the characters directly to the underlying stream. Thus redundant `DiscardableBufferedWriter`s will not copy data unnecessarily.

  Parameters:
    `cbuf` - A character array
    `off` - Offset from which to start reading characters
    `len` - Number of characters to write
  Throws:
    `java.io.IOException`

### write

    public void write(char[] buf)
               throws java.io.IOException

  Write an array of characters. This method cannot be inherited from the Writer class because it must suppress I/O exceptions.

  Throws:
    `java.io.IOException`

### write

    public void write(java.lang.String s,
                      int off,
                      int len)
               throws java.io.IOException

  Write a portion of a String.

  Parameters:
    `s` - String to be written
    `off` - Offset from which to start reading characters
    `len` - Number of characters to be written
  Throws:
    `java.io.IOException`

### write

    public void write(java.lang.String s)
               throws java.io.IOException

  Write a string. This method cannot be inherited from the Writer class because it must suppress I/O exceptions.

  Throws:
    `java.io.IOException`

### newLine

    public void newLine()
                 throws java.io.IOException

  Write a line separator. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline ('\n') character.

  Throws:
    `java.io.IOException` - If an I/O error occurs

### print

    public void print(boolean b)
               throws java.io.IOException

  Print a boolean value. The string produced by ``String.valueOf(boolean)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `b` - The `boolean` to be printed
  Throws:
    `java.io.IOException`

### print

    public void print(char c)
               throws java.io.IOException

  Print a character. The character is translated into one or more bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `c` - The `char` to be printed
  Throws:
    `java.io.IOException`

### print

    public void print(int i)
               throws java.io.IOException

  Print an integer. The string produced by ``String.valueOf(int)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `i` - The `int` to be printed
  Throws:
    `java.io.IOException`

### print

    public void print(long l)
               throws java.io.IOException

  Print a long integer. The string produced by ``String.valueOf(long)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `l` - The `long` to be printed
  Throws:
    `java.io.IOException`

### print

    public void print(float f)
               throws java.io.IOException

  Print a floating-point number. The string produced by ``String.valueOf(float)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `f` - The `float` to be printed
  Throws:
    `java.io.IOException`

### print

    public void print(double d)
               throws java.io.IOException

  Print a double-precision floating-point number. The string produced by ``String.valueOf(double)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `d` - The `double` to be printed
  Throws:
    `java.io.IOException`

### print

    public void print(char[] s)
               throws java.io.IOException

  Print an array of characters. The characters are converted into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `s` - The array of chars to be printed
  Throws:
    `java.lang.NullPointerException` - If `s` is `null`
    `java.io.IOException`

### print

    public void print(java.lang.String s)
               throws java.io.IOException

  Print a string. If the argument is `null` then the string `"null"` is printed. Otherwise, the string's characters are converted into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `s` - The `String` to be printed
  Throws:
    `java.io.IOException`

### print

    public void print(java.lang.Object obj)
               throws java.io.IOException

  Print an object. The string produced by the ``String.valueOf(Object)`` method is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Parameters:
    `obj` - The `Object` to be printed
  Throws:
    `java.io.IOException`

### println

    public void println()
                 throws java.io.IOException

  Terminate the current line by writing the line separator string. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline character (`'\n'`).

  Throws:
    `java.io.IOException`

### println

    public void println(boolean x)
                 throws java.io.IOException

  Print a boolean value and then terminate the line. This method behaves as though it invokes ``print(boolean)`` and then ``println()``.

  Throws:
    `java.io.IOException`

### println

    public void println(char x)
                 throws java.io.IOException

  Print a character and then terminate the line. This method behaves as though it invokes ``print(char)`` and then ``println()``.

  Throws:
    `java.io.IOException`

### println

    public void println(int x)
                 throws java.io.IOException

  Print an integer and then terminate the line. This method behaves as though it invokes ``print(int)`` and then ``println()``.

  Throws:
    `java.io.IOException`

### println

    public void println(long x)
                 throws java.io.IOException

  Print a long integer and then terminate the line. This method behaves as though it invokes ``print(long)`` and then ``println()``.

  Throws:
    `java.io.IOException`

### println

    public void println(float x)
                 throws java.io.IOException

  Print a floating-point number and then terminate the line. This method behaves as though it invokes ``print(float)`` and then ``println()``.

  Throws:
    `java.io.IOException`

### println

    public void println(double x)
                 throws java.io.IOException

  Print a double-precision floating-point number and then terminate the line. This method behaves as though it invokes ``print(double)`` and then ``println()``.

  Throws:
    `java.io.IOException`

### println

    public void println(char[] x)
                 throws java.io.IOException

  Print an array of characters and then terminate the line. This method behaves as though it invokes ``print(char[])`` and then ``println()``.

  Throws:
    `java.io.IOException`

### println

    public void println(java.lang.String x)
                 throws java.io.IOException

  Print a String and then terminate the line. This method behaves as though it invokes ``print(String)`` and then ``println()``.

  Throws:
    `java.io.IOException`

### println

    public void println(java.lang.Object x)
                 throws java.io.IOException

  Print an Object and then terminate the line. This method behaves as though it invokes ``print(Object)`` and then ``println()``.

  Throws:
    `java.io.IOException`

### clear

    public void clear()
               throws java.io.IOException

  Clear the contents of the buffer. If the buffer has been already been flushed then the clear operation shall throw an IOException to signal the fact that some data has already been irrevocably written to the client response stream.

  Throws:
    `java.io.IOException` - If an I/O error occurs

### clearBuffer

    public void clearBuffer()
                     throws java.io.IOException

  Clears the current contents of the buffer. Unlike clear(), this mehtod will not throw an IOException if the buffer has already been flushed. It merely clears the current content of the buffer and returns.

  Throws:
    `java.io.IOException` - If an I/O error occurs

### close

    public void close()
               throws java.io.IOException

  Close the stream, flushing it first. Once a stream has been closed, further write() or flush() invocations will cause an IOException to be thrown. Closing a previously-closed stream, however, has no effect.

  Throws:
    `java.io.IOException` - If an I/O error occurs

### getRemaining

    public int getRemaining()

  Returns:
    the number of bytes unused in the buffer

### getReader

    public java.io.Reader getReader()

  Return the value of this BodyJspWriter as a Reader. Note: this is after evaluation!! There are no scriptlets, etc in this stream.

  Returns:
    the value of this BodyJspWriter as a Reader

### getString

    public java.lang.String getString()

  Return the value of the BodyJspWriter as a String. Note: this is after evaluation!! There are no scriptlets, etc in this stream.

  Returns:
    the value of the BodyJspWriter as a String

### writeOut

    public void writeOut(java.io.Writer out)
                  throws java.io.IOException

  Write the contents of this BodyJspWriter into a Writer. Subclasses are likely to do interesting things with the implementation so some things are extra efficient.

  Parameters:
    `out` - The writer into which to place the contents of this body evaluation
  Throws:
    `java.io.IOException`

### main

    public static void main(java.lang.String[] args)
                     throws java.lang.Exception

  Throws:
    `java.lang.Exception`

Copyright ? 2000 Apache Software Foundation. All Rights Reserved.